<template>
  <div id="home">
    <main>
      <section class="logReg">
        <b-container>
          <b-col col md="6" class="forms-centered">
            <span class="title">Авторизоваться</span>
              <form class="logRegBox" @submit.prevent="userLogin">
                  <div class="form-group">
                      <label for="mail">
                        Имя пользователя
                        <span style="color:red">*</span>
                      </label>
                      <input v-model="userName" type="text"  name="userName"  class="form-control" id="userName" />
                      <div v-if="name_required" style="color:red">{{name_value}}</div>
                  </div>
                  <div class="form-group">
                      <label for="password">
                        Пароль
                        <span style="color:red">*</span>
                      </label>
                      <input v-model="password" type="password"   name="password"   class="form-control" id="password" />
                      <div v-if="pass_required" style="color:red">{{pass_value}}</div>
                  </div>
                  <div class="form-group">
                    <input  type="submit" class="submit-button btn-4 w-100" value="Авторизоваться" />
                  </div>
                  <div v-if="nan_field_errors" style="color:red">{{error}}</div>
                  <div class="form-group sign-in-up">
                    <span @click.prevent="userRegister"><a href="javascript.void(0)"> Регистрация </a> </span>
                  </div>
              </form>
            </b-col>
         </b-container>
      </section>

    </main>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from "vuex";
import { Token } from "../router/Auth";

export default {
  components: {
   
  },
  data() {
    return {
      userName: "",
      password: "",

      name_value: "",
      pass_value: "",
      error: "",

      name_required: false,
      pass_required: false,
      nan_field_errors: false
    };
  },
  methods: {
    ...mapActions(["Login"]),

    userLogin() {
          this.Login({
            username: this.userName,
            password: this.password
          })
            .then(res => {
            if(res.status == 200){
              this.$router.push("/");
            }
          })
            .catch(err => {
  
              if(err.response.data.username == "Это поле не может быть пустым."){
                this.name_required = true;
                this.name_value = "Это поле не может быть пустым."
              }
              if(err.response.data.password == "Это поле не может быть пустым."){
                this.pass_required = true;
                this.pass_value = "Это поле не может быть пустым."
              }
              if(err.response.data.non_field_errors){
                this.nan_field_errors = true;
                this.error = "Невозможно войти с предоставленными учетными данными."
              }
              console.log(err)
          });
        },

    userRegister(){
      this.$router.push('/register')
    },

  },
  created() {
    if (Token.get.token()) {
      this.$router.push("/");
    }
  }
};
</script>
<style scoped>
 .forms-centered{
   height: 310px
 }
</style>
